1.题目基本信息
1.1.题目描述
你准备参加一场远足活动。给你一个二维 rows x columns 的地图 heights ,其中 heights[row][col] 表示格子 (row, col) 的高度。一开始你在最左上角的格子 (0, 0) ,且你希望去最右下角的格子 (rows-1, columns-1) (注意下标从 0 开始编号)。你每次可以往 上,下,左,右 四个方向之一移动,你想要找到耗费 体力 最小的一条路径。
一条路径耗费的 体力值 是路径上相邻格子之间 高度差绝对值 的 最大值 决定的。
请你返回从左上角走到右下角的最小 体力消耗值 。
1.2.题目地址
https://leetcode.cn/problems/path-with-minimum-effort/description/
2.解题方法
2.1.解题思路
二分查找你+广度优先搜索
2.2.解题步骤
第一步,初始化体力消耗值的边界值,最小为0,最大为106-1(因为height值<=106)
第二步,定义check函数,判断体力值HP是否能完成从左上角到右下角的任务,使用广度有效搜索的方法判断是否能到达
第三步,红蓝染色法特征定义。红:在当前体力消耗值a下,不能完成从左上角到右下角的任务的项,蓝:在当前体力消耗值下,能完成任务的项。左闭右闭:left-1始终指向红色,right+1始终指向蓝色。最终的left和right+1即为最小体力消耗值
3.解题代码
Python代码
from collections import deque
class Solution:
# 二分查找你+广度优先搜索
def minimumEffortPath(self, heights: List[List[int]]) -> int:
rows,cols=len(heights),len(heights[0])
# 第一步,初始化体力消耗值的边界值,最小为0,最大为10**6-1(因为height值<=10**6)
# 第二步,定义check函数,判断体力值HP是否能完成从左上角到右下角的任务,使用广度有效搜索的方法判断是否能到达
# 第三步,红蓝染色法特征定义。红:在当前体力消耗值a下,不能完成从左上角到右下角的任务的项,蓝:在当前体力消耗值下,能完成任务的项。左闭右闭:left-1始终指向红色,right+1始终指向蓝色。最终的left和right+1即为最小体力消耗值
def check(hitPoint):
# 检查在体力hitPoint下能否完成从左上角到右下角的任务
que=deque([(0,0)])
seen=set([(0,0)])
while que:
for i in range(len(que)):
item=que.popleft()
# 注意:在一定条件下,这里可以往左和上走
for direct in [[0,1],[1,0],[-1,0],[0,-1]]:
nextPoint=(item[0]+direct[0],item[1]+direct[1])
if 0<=nextPoint[0]<rows and 0<=nextPoint[1]<cols and abs(heights[nextPoint[0]][nextPoint[1]]-heights[item[0]][item[1]])<=hitPoint and nextPoint not in seen:
que.append(nextPoint)
seen.add(nextPoint)
return (rows-1,cols-1) in seen
left,right=0,10**6-1
while left<=right:
mid=(right-left)//2+left
if not check(mid):
left=mid+1
else:
right=mid-1
return left
C++代码
class Solution {
public:
int directions[4][2]={{0,1},{1,0},{-1,0},{0,-1}};
bool check(int hitPoint,vector<vector<int>>& heights){
int rows=heights.size(),cols=heights[0].size();
queue<pair<int,int>> que;
que.emplace(0,0);
vector<int> seen(rows * cols);
seen[0] = 1;
while(!que.empty()){
for(int i=0;i<que.size();++i){
auto item=que.front();
que.pop();
for(auto direct:directions){
int nextX=item.first+direct[0];
int nextY=item.second+direct[1];
int val=nextX*cols+nextY;
if(0<=nextX && nextX<rows && 0<=nextY && nextY<cols && abs(heights[nextX][nextY]-heights[item.first][item.second])<=hitPoint && !seen[val]){
que.emplace(nextX,nextY);
seen[val] = 1;
}
}
}
}
return true ? seen[rows*cols-1]==1 : false;
}
int minimumEffortPath(vector<vector<int>>& heights) {
int left=0,right=999999;
while(left<=right){
int mid=(right-left)/2+left;
if(!check(mid,heights)){
left=mid+1;
}else{
right=mid-1;
}
}
return left;
}
};